library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity count12 is
  port(Clock : in std_logic;
       Q : out std_logic_vector(11 downto 0);
       Aclr : in std_logic;
       Tcnt : out std_logic);
end count12;

architecture behavioral of count12 is

  signal Qaux : UNSIGNED(11 downto 0);

begin

  process(Clock, Aclr)
  begin

    if (Aclr = '0') then
      Qaux <= (others => '0');
    elsif (Clock'event and Clock = '1') then
      Qaux <= Qaux + 1;
    end if;

  end process;

  Q <= std_logic_vector(Qaux);

  process(Qaux)
    variable aux : std_logic;
  begin

    aux := '1';
    for I in 0 to 11 loop
      if (Qaux(I) = '0') then
        aux := '0';
      end if;
    end loop;

    Tcnt <= aux;

  end process;

end behavioral;
