--#####################################################################
-- component voltage_n120_120_50_33_smtr_wrapper
-- port ( 
--     CLK:in std_logic;
--     NRESET:in std_logic;
--     EV_CHHOLD:in std_logic_vector(4 downto 0);
--     EV_DONE:in std_logic;
--     EV_RAM_WR_BUSY_B:in std_logic;
--     GPI:in std_logic_vector((((2**0)*32)-1) downto 0);
--     GPO:out std_logic_vector((((2**0)*32)-1) downto 0);
--     INIT_ADDR:in std_logic_vector(9-1 downto 0);
--     INIT_TR_WR:in std_logic;
--     INIT_DI:in std_logic_vector(8 downto 0);
--     INIT_DONE:in std_logic;
--     USER_TR_ADDR:in std_logic_vector(9-1 downto 0);
--     USER_TR_RD:in std_logic;
--     USER_TR_RAM_BUSY:out std_logic;
--     TR_EV_ADDR:out std_logic_vector(9-1 downto 0);
--     TR_EV_RD:out std_logic;
--     TR_TRFLAG:out std_logic;
--     TR_DONE:out std_logic;
--     EV_RAM_DO_A:in std_logic_vector(8 downto 0);
--     TR_RAM_ADDR_A:out std_logic_vector(9-1 downto 0);
--     TR_RAM_RW_A:out std_logic;
--     TR_RAM_CSN_A:out std_logic;
--     TR_RAM_DI_A:out std_logic_vector(8 downto 0);
--     TR_RAM_ADDR_B:out std_logic_vector(9-1 downto 0);
--     TR_RAM_RW_B:out std_logic;
--     TR_RAM_CSN_B:out std_logic;
--     TR_RAM_DI_B:out std_logic_vector(8 downto 0);
--     TR_RAM_DO_B:in std_logic_vector(8 downto 0);
--     TR_RAM_WR_BUSY_B:out std_logic
--      );
-- end component;

--U0:voltage_n120_120_50_33_smtr_wrapper
--port map(
--         CLK=>  ;
--         NRESET=>  ;
--         EV_CHHOLD=>  ;
--         EV_DONE=>  ;
--         EV_RAM_WR_BUSY_B=>  ;
--         GPI=>  ;
--         GPO=>  ;
--         INIT_ADDR=>  ;
--         INIT_TR_WR=>  ;
--         INIT_DI=>  ;
--         INIT_DONE=>  ;
--         USER_TR_ADDR=>  ;
--         USER_TR_RD=>  ;
--         USER_TR_RAM_BUSY=>  ;
--         TR_EV_ADDR=>  ;
--         TR_EV_RD=>  ;
--         TR_TRFLAG=>  ;
--         TR_DONE=>  ;
--         EV_RAM_DO_A=>  ;
--         TR_RAM_ADDR_A=>  ;
--         TR_RAM_RW_A=>  ;
--         TR_RAM_CSN_A=>  ;
--         TR_RAM_DI_A=>  ;
--         TR_RAM_ADDR_B=>  ;
--         TR_RAM_RW_B=>  ;
--         TR_RAM_CSN_B=>  ;
--         TR_RAM_DI_B=>  ;
--         TR_RAM_DO_B=>  ;
--         TR_RAM_WR_BUSY_B=>  
--        );
--#####################################################################


library IEEE ;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity voltage_n120_120_50_33_smtr_wrapper is  
port ( 
     CLK:in std_logic;
     NRESET:in std_logic;
     EV_CHHOLD:in std_logic_vector(4 downto 0);
     EV_DONE:in std_logic;
     EV_RAM_WR_BUSY_B:in std_logic;
     GPI:in std_logic_vector((((2**0)*32)-1) downto 0);
     GPO:out std_logic_vector((((2**0)*32)-1) downto 0);
     INIT_ADDR:in std_logic_vector(9-1 downto 0);
     INIT_TR_WR:in std_logic;
     INIT_DI:in std_logic_vector(8 downto 0);
     INIT_DONE:in std_logic;
     USER_TR_ADDR:in std_logic_vector(9-1 downto 0);
     USER_TR_RD:in std_logic;
     USER_TR_RAM_BUSY:out std_logic;
     TR_EV_ADDR:out std_logic_vector(9-1 downto 0);
     TR_EV_RD:out std_logic;
     TR_TRFLAG:out std_logic;
     TR_DONE:out std_logic;
     EV_RAM_DO_A:in std_logic_vector(8 downto 0);
     TR_RAM_ADDR_A:out std_logic_vector(9-1 downto 0);
     TR_RAM_RW_A:out std_logic;
     TR_RAM_CSN_A:out std_logic;
     TR_RAM_DI_A:out std_logic_vector(8 downto 0);
     TR_RAM_ADDR_B:out std_logic_vector(9-1 downto 0);
     TR_RAM_RW_B:out std_logic;
     TR_RAM_CSN_B:out std_logic;
     TR_RAM_DI_B:out std_logic_vector(8 downto 0);
     TR_RAM_DO_B:in std_logic_vector(8 downto 0);
     TR_RAM_WR_BUSY_B:out std_logic
     );
end voltage_n120_120_50_33_smtr_wrapper;

architecture DEF_ARCH of voltage_n120_120_50_33_smtr_wrapper is

component SMTR

generic(
     GPI_BITS:integer;
     GPO_BITS:integer;
     ALLOW_USER_TR:integer;
     EV_ASIZE:integer;
     TR_ASIZE:integer
        );
port(
     CLK:in std_logic;
     NRESET:in std_logic;
     EV_CHHOLD:in std_logic_vector(4 downto 0);
     EV_DONE:in std_logic;
     EV_RAM_WR_BUSY_B:in std_logic;
     GPI:in std_logic_vector((((2**GPI_BITS)*32)-1) downto 0);
     GPO:out std_logic_vector((((2**GPO_BITS)*32)-1) downto 0);
     INIT_ADDR:in std_logic_vector(TR_ASIZE-1 downto 0);
     INIT_TR_WR:in std_logic;
     INIT_DI:in std_logic_vector(8 downto 0);
     INIT_DONE:in std_logic;
     USER_TR_ADDR:in std_logic_vector(TR_ASIZE-1 downto 0);
     USER_TR_RD:in std_logic;
     USER_TR_RAM_BUSY:out std_logic;
     TR_EV_ADDR:out std_logic_vector(EV_ASIZE-1 downto 0);
     TR_EV_RD:out std_logic;
     TR_TRFLAG:out std_logic;
     TR_DONE:out std_logic;
     EV_RAM_DO_A:in std_logic_vector(8 downto 0);
     TR_RAM_ADDR_A:out std_logic_vector(TR_ASIZE-1 downto 0);
     TR_RAM_RW_A:out std_logic;
     TR_RAM_CSN_A:out std_logic;
     TR_RAM_DI_A:out std_logic_vector(8 downto 0);
     TR_RAM_ADDR_B:out std_logic_vector(TR_ASIZE-1 downto 0);
     TR_RAM_RW_B:out std_logic;
     TR_RAM_CSN_B:out std_logic;
     TR_RAM_DI_B:out std_logic_vector(8 downto 0);
     TR_RAM_DO_B:in std_logic_vector(8 downto 0);
     TR_RAM_WR_BUSY_B:out std_logic
     );
end component;

begin

U0:SMTR
generic map(
             GPI_BITS=>0,
             GPO_BITS=>0,
             ALLOW_USER_TR=>0,
             EV_ASIZE=>9,
             TR_ASIZE=>9
           )

port map(
         CLK=>CLK,
         NRESET=>NRESET,
         EV_CHHOLD=>EV_CHHOLD,
         EV_DONE=>EV_DONE,
         EV_RAM_WR_BUSY_B=>EV_RAM_WR_BUSY_B,
         GPI=>GPI,
         GPO=>GPO,
         INIT_ADDR=>INIT_ADDR,
         INIT_TR_WR=>INIT_TR_WR,
         INIT_DI=>INIT_DI,
         INIT_DONE=>INIT_DONE,
         USER_TR_ADDR=>USER_TR_ADDR,
         USER_TR_RD=>USER_TR_RD,
         USER_TR_RAM_BUSY=>USER_TR_RAM_BUSY,
         TR_EV_ADDR=>TR_EV_ADDR,
         TR_EV_RD=>TR_EV_RD,
         TR_TRFLAG=>TR_TRFLAG,
         TR_DONE=>TR_DONE,
         EV_RAM_DO_A=>EV_RAM_DO_A,
         TR_RAM_ADDR_A=>TR_RAM_ADDR_A,
         TR_RAM_RW_A=>TR_RAM_RW_A,
         TR_RAM_CSN_A=>TR_RAM_CSN_A,
         TR_RAM_DI_A=>TR_RAM_DI_A,
         TR_RAM_ADDR_B=>TR_RAM_ADDR_B,
         TR_RAM_RW_B=>TR_RAM_RW_B,
         TR_RAM_CSN_B=>TR_RAM_CSN_B,
         TR_RAM_DI_B=>TR_RAM_DI_B,
         TR_RAM_DO_B=>TR_RAM_DO_B,
         TR_RAM_WR_BUSY_B=>TR_RAM_WR_BUSY_B
        );
end DEF_ARCH;
